﻿Imports System.IO
Imports System.ComponentModel

Public Class Form1

    Private PdfView As PdfViewer
    Private m_PageCount As Integer

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load

        Button1.Enabled = False
        VScrollBar1.Enabled = False

        PdfView = New PdfViewer

        Me.MinimumSize = New Size(300, 300)

        If PdfView.GetIsPdfFactoryActivated Then Button1.Enabled = True
    End Sub

    Private Sub Form1_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        PdfView.Dispose()
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim strFileName As String = String.Empty

        Using OFD As New OpenFileDialog
            With OFD
                .Title = "Open PDF"
                .Filter = "PDF Files (*.pdf)|*.pdf"
                .ShowDialog()
                strFileName = .FileName
            End With
        End Using

        If Not String.IsNullOrEmpty(strFileName) Then

            If Path.GetExtension(strFileName).ToLower = ".pdf" Then

                PdfView.PdfFile = strFileName

                If PdfView.LoadPdfFile Then

                    With VScrollBar1
                        .Enabled = False
                        .Maximum = 0
                        .Value = 0
                    End With

                    m_PageCount = PdfView.GetPdfPageCount

                    If m_PageCount > 0 Then

                        With VScrollBar1
                            .Maximum = m_PageCount - 1
                            .Enabled = True
                        End With

                        GetPdfPage(0)

                    End If

                End If

            End If

        End If

    End Sub

    Private Sub VScrollBar1_ValueChanged(sender As Object, e As EventArgs) Handles VScrollBar1.ValueChanged
        If Me.WindowState <> FormWindowState.Minimized Then
            If m_PageCount > 0 Then GetPdfPage(VScrollBar1.Value)
        End If
    End Sub

    Private Sub PictureBox1_Resize(sender As Object, e As EventArgs) Handles PictureBox1.Resize
        If Me.WindowState <> FormWindowState.Minimized Then
            If m_PageCount > 0 Then GetPdfPage(VScrollBar1.Value)
        End If
    End Sub

    Private Sub GetPdfPage(PageIndex As Integer)

        Label1.Text = "Page " & (PageIndex + 1).ToString & " from " & m_PageCount.ToString

        Dim sngPageRatio As Single
        Dim tSizeF As SizeF = PdfView.GetPdfPageSize(PageIndex)
        Dim sngRatioX As Single = (PictureBox1.Width - 20) / tSizeF.Width
        Dim sngRatioY As Single = (PictureBox1.Height - 20) / tSizeF.Height

        If sngRatioX > sngRatioY Then sngPageRatio = sngRatioY Else sngPageRatio = sngRatioX

        PdfView.UseScaleFactorForAllPdfPages = True
        PdfView.ScaleFactorForAllPdfPages = sngPageRatio

        Dim bmpPage As Bitmap = PdfView.GetPdfPageAsBitmap(PageIndex)
        If bmpPage IsNot Nothing Then

            If PictureBox1.BackgroundImage IsNot Nothing Then PictureBox1.BackgroundImage.Dispose()

            PictureBox1.BackgroundImageLayout = ImageLayout.Center
            PictureBox1.BackgroundImage = bmpPage

        End If

    End Sub

End Class
